/*  -*- mode: C++; c-file-style: "gnu" -*-
 *
 *  This file is part of KMail, the KDE mail client.
 *  Copyright (c) 2003 Zack Rusin <zack@kde.org>
 *
 *  KMail is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License, version 2, as
 *  published by the Free Software Foundation.
 *
 *  KMail is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *  In addition, as a special exception, the copyright holders give
 *  permission to link the code of this program with any edition of
 *  the TQt library by Trolltech AS, Norway (or with modified versions
 *  of TQt that use the same license as TQt), and distribute linked
 *  combinations including the two.  You must obey the GNU General
 *  Public License in all respects for all of the code used other than
 *  TQt.  If you modify this file, you may extend this exception to
 *  your version of the file, but you are not obligated to do so.  If
 *  you do not wish to do so, delete this exception statement from
 *  your version.
 */

#ifndef FOLDERIFACE_H
#define FOLDERIFACE_H

#include <tqobject.h>
#include <dcopobject.h>

class KMFolder;
class KMMainWidget;

namespace KMail {

  class FolderIface : public TQObject,
                      public DCOPObject
  {
    Q_OBJECT
//  
    K_DCOP

  public:
    FolderIface( const TQString& vpath );

  k_dcop:
    virtual TQString path() const;
    virtual TQString displayName() const;
    virtual TQString displayPath() const;
    virtual bool usesCustomIcons() const;
    virtual TQString normalIconPath() const;
    virtual TQString unreadIconPath() const;
    virtual int messages();
    virtual int unreadMessages();
    virtual int unreadRecursiveMessages();

    //not yet
    //virtual TQValueList<DCOPRef> messageRefs();
  protected:
    KMFolder* mFolder;
    TQString   mPath;
  };

}

#endif
